<?php
namespace SM\Service;

use SM\Factory\JustifCancelaApurFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class JustifCancelaApurService
{

    protected $justifCancelaApurFactory;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, JustifCancelaApurFactory $justifCancelaApurFactory, Environment $environment, NewCode $newCode)
    {
        $this->connection               = $entityManager->getConnection();
        $this->justifCancelaApurFactory = $justifCancelaApurFactory;
        $this->environment              = $environment;
        $this->newCode                  = $newCode;
    }

    public function getJustifCancelaApur()
    {
        return $this->justifCancelaApurFactory->getJustifCancelaApur();
    }

    public function editJustifCancelaApur($params)
    {
        $this->connection->beginTransaction();
       
        try {
            $nrorg = $this->environment->getNrorg();
            $operador = $this->environment->getCdOperador();
            
            foreach ($params["DRG"] as $row) {
                if ($row["NRJUSTIFCANCELAAPUR"] != 0) {
                    $parametros = array (
                        "NRJUSTIFCANCELAAPUR" => $row["NRJUSTIFCANCELAAPUR"],
                        "DSJUSTIFCANCELAAPUR" => $row['DSJUSTIFCANCELAAPUR'],
                        "IDATIVO"             => $row["IDATIVO"],
                        "NRORGULTATU"         => $nrorg,
                        "CDOPERULTATU"        => $operador
                    );
                    
                    $this->justifCancelaApurFactory->editJustifCancelaApur($parametros);
                } else {
                    $NRJUSTIFCANCELAAPUR = $this->newCode->getCodeByTableName("FCT_TIPORESCISAO", $nrorg, 1, 10, true);
                    $parametros = array (
                        "NRJUSTIFCANCELAAPUR" => $NRJUSTIFCANCELAAPUR,
                        "DSJUSTIFCANCELAAPUR" => $row['DSJUSTIFCANCELAAPUR'],
                        "IDATIVO"             => "S",
                        "NRORG"               => $nrorg,
                        "NRORGINCLUSAO"       => $nrorg,
                        "CDOPERINCLUSAO"      => $operador
                    );
                    
                    $this->justifCancelaApurFactory->insertJustifCancelaApur($parametros);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteJustifCancelaApur($parametro)
    {
        $param = implode(',', $parametro["NRS"]);
        $this->justifCancelaApurFactory->deleteJustifCancelaApur($param);
    }
}
