/*JOBS q disparam procedures dos Dashboards*/

/* DESATIVAR JOB DO REPLICA_VENDAS_RM*/
BEGIN

DECLARE
	V_COUNT NUMBER;
	BEGIN
	  V_COUNT := 0;
	  BEGIN
		 SELECT COUNT(*)
		   INTO V_COUNT
		   FROM USER_SCHEDULER_JOBS
		  WHERE JOB_NAME = 'JOB_REPLICA_VENDAS_RM';
	  EXCEPTION
		 WHEN NO_DATA_FOUND THEN
			V_COUNT := 0;
	  END;
	  IF V_COUNT > 0 THEN
		 DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_REPLICA_VENDAS_RM');
	  END IF;
	END;
END;

/

/* JOB VENDAS Dashboards*/
 BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM USER_SCHEDULER_JOBS
          WHERE JOB_NAME = 'JOB_VENDAS_DASHBOARD';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_VENDAS_DASHBOARD',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN DASHBOARD_VND_CARDS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=MINUTELY;INTERVAL=45',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar vendas nas tabelas dos Dashboards'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_VENDAS_DASHBOARD');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_VENDAS_DASHBOARD',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN DASHBOARD_VND_CARDS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=MINUTELY;INTERVAL=45',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar vendas nas tabelas dos Dashboards'
         );
      END IF;
   END;
END;

/


/* JOB CMV Dashboard versao CORPORATIVO*/
BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM USER_SCHEDULER_JOBS
          WHERE JOB_NAME = 'JOB_DASHBOARD_VND_CM';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_DASHBOARD_VND_CM',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN DASHBOARD_VND_CMV(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=DAILY;BYHOUR=5',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar dados de CMVs na tabela VNDCARDS.'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_DASHBOARD_VND_CM');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_DASHBOARD_VND_CM',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN DASHBOARD_VND_CMV(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=DAILY;BYHOUR=5',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar dados de CMVs na tabela VNDCARDS.'
         );
      END IF;
   END;
END;

/

/* JOB FINAN Dashboard versao CORPORATIVO*/
BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM USER_SCHEDULER_JOBS
          WHERE JOB_NAME = 'JOB_DASHBOARD_ERP_RETAIL';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_DASHBOARD_ERP_RETAIL',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN JOB_FINAN_GIRAFFAS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=MINUTELY;INTERVAL=10',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar tabela do financeiro versao CORPORATIVO'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_DASHBOARD_ERP_RETAIL');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_DASHBOARD_ERP_RETAIL',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN JOB_FINAN_GIRAFFAS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=MINUTELY;INTERVAL=10',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar tabela do financeiro versao CORPORATIVO'
         );
      END IF;
   END;
END;
/